using System;
using Word;
using System.Reflection;

namespace Word2Html
{

	
	class WordToHtml
	{
		public bool DocToHtml(string docPath,string htmlPath)
		{
			try
			{
				Word.Application app=new Application();
				app.Visible=false;
				Object o= System.Reflection.Missing.Value;
				object docFile=docPath;
				_Document doc=app.Documents.Open(ref docFile,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o); //office 2000
				//_Document doc=app.Documents.Open(ref docFile,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o);  //office 2003
				object fileName=htmlPath;
				object format=8; //Html
				doc.SaveAs(ref fileName,ref format,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o);   //office 2000
				//doc.SaveAs(ref fileName,ref format,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o,ref o); //office 2003
				
				object t=true;
				app.Quit(ref t,ref o,ref o);
				return true;
			}
			catch(Exception e)
			{
				return false;
			}
		}
		public string ChangeExt(string filename)
		{
			int len = filename.LastIndexOf('.');
			string t = filename.Substring(0, len);
			string temp = t + ".html";
			return temp;
		}
		[STAThread]
		static void Main(string[] args)
		{
			WordToHtml c= new WordToHtml();
			if(args.Length > 0)
			{
				Console.Out.WriteLine(args[0].ToString());
				for(int i=0 ; i< args.Length;i++)
				{
					if(c.DocToHtml(args[i],c.ChangeExt(args[i])))
					{
						Console.Out.WriteLine("Converted " + args[i] + " to " + c.ChangeExt(args[i]) + " successful.");
					}
					else
					{
						Console.Out.WriteLine("Could not convert " + args[i] + ".");
					}
				}
			}
			else
			{
				Console.Out.Write("Word document to convert: ");
				string file = Console.ReadLine();
				if(c.DocToHtml(file,c.ChangeExt(file)))
				{
					Console.Out.WriteLine("Converted " + file + " to " + c.ChangeExt(file) + " successful.");
				}
				else
				{
					Console.Out.WriteLine("Could not convert " + file + ".");
				}
			}
		}
	}
}
